=== modified file 'bzrlib/bzrdir.py'
--- bzrlib/bzrdir.py	2011-12-09 04:17:50 +0000
+++ bzrlib/bzrdir.py	2011-12-11 04:11:49 +0000
@@ -1046,20 +1046,6 @@
                 self.control_files.unlock()
         self.transport.delete_tree(path)
 
-    def list_branches(self):
-        """See ControlDir.list_branches."""
-        ret = []
-        # Default branch
-        try:
-            ret.append(self.open_branch())
-        except (errors.NotBranchError, errors.NoRepositoryPresent):
-            pass
-
-        # colocated branches
-        ret.extend([self.open_branch(name.decode("utf-8")) for name in
-                    self._read_branch_list()])
-        return ret
-
     def get_branches(self):
         """See ControlDir.get_branches."""
         ret = {}

=== modified file 'bzrlib/controldir.py'
--- bzrlib/controldir.py	2011-12-09 04:17:50 +0000
+++ bzrlib/controldir.py	2011-12-11 04:11:49 +0000
@@ -106,17 +106,13 @@
         """Return a sequence of all branches local to this control directory.
 
         """
-        try:
-            return [self.open_branch()]
-        except (errors.NotBranchError, errors.NoRepositoryPresent):
-            return []
+        return self.get_branches().values()
 
     def get_branches(self):
         """Return a dictionary with branch_names and branch objects."""
-        branches = self.list_branches()
-        if branches:
-           return {None:branches[0]}
-        else:
+        try:
+           return {None:self.open_branch()}
+        except (errors.NotBranchError, errors.NoRepositoryPresent):
            return {}
 
     def is_control_filename(self, filename):

